lib/test_kasan.c: make kmalloc_oob_krealloc_less more correctly
[deliverable/linux.git] / scripts / kconfig / Makefile
CommitLineData
1da177e4
LT
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
1cba0c30 5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 6 localmodconfig localyesconfig
1da177e4 7
61bee204
AV
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
838a2e55 11Kconfig := Kconfig
61bee204 12endif
e703f75d 13
0a1f00a1
MM
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
c2838e6e
YM
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
1da177e4 21xconfig: $(obj)/qconf
0a1f00a1 22 $< $(silent) $(Kconfig)
1da177e4
LT
23
24gconfig: $(obj)/gconf
0a1f00a1 25 $< $(silent) $(Kconfig)
1da177e4
LT
26
27menuconfig: $(obj)/mconf
0a1f00a1 28 $< $(silent) $(Kconfig)
1da177e4
LT
29
30config: $(obj)/conf
0a1f00a1 31 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 32
692d97c3 33nconfig: $(obj)/nconf
0a1f00a1 34 $< $(silent) $(Kconfig)
692d97c3 35
1da177e4 36silentoldconfig: $(obj)/conf
9815594a 37 $(Q)mkdir -p include/config include/generated
0a1f00a1 38 $< $(silent) --$@ $(Kconfig)
1da177e4 39
50bce3e8 40localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 41 $(Q)mkdir -p include/config include/generated
22d550ae 42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 43 $(Q)if [ -f .config ]; then \
4062f1a4
SR
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
0a1f00a1 47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
4062f1a4
SR
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
0a1f00a1 51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
a7c02602 52 fi
03fa25da
SR
53 $(Q)rm -f .tmp.config
54
1020026f 55# Create new linux.pot file
b70e325c 56# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 57update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 58 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
1020026f 68 do \
0a1f00a1 69 $(kecho) " GEN $$i"; \
4217516e 70 $(obj)/kxgettext $$i \
1020026f
EG
71 >> $(obj)/config.pot; \
72 done )
0a1f00a1 73 $(Q)$(kecho) " GEN linux.pot"
1020026f 74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 75 --output $(obj)/linux.pot
b70e325c 76 $(Q)rm -f $(obj)/config.pot
3b9fa093 77
1cba0c30
MM
78# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
1da177e4 82
1cba0c30 83$(simple-targets): $(obj)/conf
0a1f00a1 84 $< $(silent) --$@ $(Kconfig)
1da177e4 85
1cba0c30 86PHONY += oldnoconfig savedefconfig defconfig
1da177e4 87
fb16d891 88# oldnoconfig is an alias of olddefconfig, because people already are dependent
39c3f1ba 89# on its behavior (sets new symbols to their default value but not 'n') with the
fb16d891 90# counter-intuitive name.
1cba0c30 91oldnoconfig: olddefconfig
fb16d891 92
7cf3d73b 93savedefconfig: $(obj)/conf
0a1f00a1 94 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 95
1da177e4
LT
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 98 $< $(silent) --defconfig $(Kconfig)
1da177e4 99else
0a1f00a1
MM
100 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
1da177e4
LT
102endif
103
104%_defconfig: $(obj)/conf
0a1f00a1 105 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 106
63a91033 107configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 108
63a91033
MY
109%.config: $(obj)/conf
110 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
111 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
112 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
113
114PHONY += kvmconfig
63a91033
MY
115kvmconfig: kvm_guest.config
116 @:
3aaefce1 117
6c668505
LR
118PHONY += xenconfig
119xenconfig: xen.config
120 @:
121
0da1d4a0 122PHONY += tinyconfig
63a91033
MY
123tinyconfig:
124 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 125
1da177e4
LT
126# Help text used by make help
127help:
128 @echo ' config - Update current config utilising a line-oriented program'
fa75a727
GU
129 @echo ' nconfig - Update current config utilising a ncurses menu based'
130 @echo ' program'
1da177e4 131 @echo ' menuconfig - Update current config utilising a menu based program'
092373c2 132 @echo ' xconfig - Update current config utilising a Qt based front-end'
39c3f1ba 133 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
1da177e4 134 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 135 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 136 @echo ' localyesconfig - Update current config converting local mods to core'
590a5857 137 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
0748cb3e 138 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 139 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 140 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
141 @echo ' allyesconfig - New config where all options are accepted with yes'
142 @echo ' allmodconfig - New config selecting modules when possible'
143 @echo ' alldefconfig - New config with all symbols set to default'
144 @echo ' randconfig - New config with random answer to all options'
861b4ea4 145 @echo ' listnewconfig - List new options'
fa75a727
GU
146 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
147 @echo ' default value'
9bcd776d 148 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
6c668505 149 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
0da1d4a0 150 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 151
2982de69
SR
152# lxdialog stuff
153check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
154
e9e40e14 155# Use recursively expanded variables so we do not call gcc unless
2982de69 156# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
157HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
158 -DLOCALE
2982de69 159
1da177e4
LT
160# ===========================================================================
161# Shared Makefile for the various kconfig executables:
162# conf: Used for defconfig, oldconfig and related targets
692d97c3 163# nconf: Used for the nconfig target.
164# Utilizes ncurses
6f26e5e4 165# mconf: Used for the menuconfig target
1da177e4
LT
166# Utilizes the lxdialog package
167# qconf: Used for the xconfig target
092373c2 168# Based on Qt which needs to be installed to compile it
1da177e4 169# gconf: Used for the gconfig target
39c3f1ba 170# Based on GTK+ which needs to be installed to compile it
1da177e4
LT
171# object files used by all kconfig flavours
172
2982de69
SR
173lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
174lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
175
1da177e4 176conf-objs := conf.o zconf.tab.o
692d97c3 177mconf-objs := mconf.o zconf.tab.o $(lxdialog)
178nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 179kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 180qconf-cxxobjs := qconf.o
5a6f8d2b
AL
181qconf-objs := zconf.tab.o
182gconf-objs := gconf.o zconf.tab.o
1da177e4 183
022af62d 184hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 185
5a6f8d2b 186clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
2f76b358 187clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
1020026f 188clean-files += config.pot linux.pot
1da177e4 189
6e588f6d
SR
190# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
191PHONY += $(obj)/dochecklxdialog
192$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
193$(obj)/dochecklxdialog:
7080e47b 194 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
195
196always := dochecklxdialog
197
aa1e5ef5
SR
198# Add environment specific flags
199HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
70a6a0cb 200
1da177e4 201# generated files seem to need this to find local include files
2f76b358 202HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
203HOSTCFLAGS_zconf.tab.o := -I$(src)
204
378dbb2c
AL
205LEX_PREFIX_zconf := zconf
206YACC_PREFIX_zconf := zconf
207
5a6f8d2b
AL
208HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
209HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 210
5a6f8d2b 211HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 212HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 213 -Wno-missing-prototypes
1da177e4 214
7080e47b
AL
215HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
216
544e7e54 217HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
218 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
219 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 220 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
221$(obj)/qconf.o: $(obj)/.tmp_qtcheck
222
022af62d 223ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 224$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
225-include $(obj)/.tmp_qtcheck
226
092373c2 227# Qt needs some extra effort...
1da177e4 228$(obj)/.tmp_qtcheck:
0a1f00a1 229 @set -e; $(kecho) " CHECK qt"; dir=""; pkg=""; \
133c5f7c 230 if ! pkg-config --exists QtCore 2> /dev/null; then \
092373c2 231 echo "* Unable to find the Qt4 tool qmake. Trying to use Qt3"; \
133c5f7c
AS
232 pkg-config --exists qt 2> /dev/null && pkg=qt; \
233 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
234 if [ -n "$$pkg" ]; then \
235 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
236 libs="\$$(shell pkg-config $$pkg --libs)"; \
237 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
238 dir="$$(pkg-config $$pkg --variable=prefix)"; \
239 else \
240 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
241 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
242 done; \
243 if [ -z "$$dir" ]; then \
5b580fa6 244 echo >&2 "*"; \
092373c2
DV
245 echo >&2 "* Unable to find any Qt installation. Please make sure that"; \
246 echo >&2 "* the Qt4 or Qt3 development package is correctly installed and"; \
5b580fa6
MM
247 echo >&2 "* either qmake can be found or install pkg-config or set"; \
248 echo >&2 "* the QTDIR environment variable to the correct location."; \
249 echo >&2 "*"; \
133c5f7c
AS
250 false; \
251 fi; \
252 libpath=$$dir/lib; lib=qt; osdir=""; \
253 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
254 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
255 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
256 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
257 cflags="-I$$dir/include"; \
258 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
259 moc="$$dir/bin/moc"; \
260 fi; \
261 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
262 echo "*"; \
263 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
264 echo "*"; \
265 moc="/usr/bin/moc"; \
266 fi; \
ab919c06 267 else \
458452f4
MM
268 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
269 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
48485949
YS
270 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
271 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
b3a5225f
RZ
272 fi; \
273 echo "KC_QT_CFLAGS=$$cflags" > $@; \
274 echo "KC_QT_LIBS=$$libs" >> $@; \
275 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
276endif
277
278$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
279
022af62d 280ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
281-include $(obj)/.tmp_gtkcheck
282
39c3f1ba 283# GTK+ needs some extra effort, too...
1da177e4 284$(obj)/.tmp_gtkcheck:
37193147
AB
285 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
286 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
287 touch $@; \
288 else \
5b580fa6
MM
289 echo >&2 "*"; \
290 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
291 echo >&2 "*"; \
1da177e4
LT
292 false; \
293 fi \
294 else \
5b580fa6
MM
295 echo >&2 "*"; \
296 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
297 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
298 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
299 echo >&2 "*"; \
1da177e4
LT
300 false; \
301 fi
302endif
303
2f76b358 304$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
1da177e4 305
5a6f8d2b 306$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 307
ebca026a
YS
308quiet_cmd_moc = MOC $@
309 cmd_moc = $(KC_QT_MOC) -i $< -o $@
310
311$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
312 $(call cmd,moc)
1da177e4 313
39c3f1ba 314# Extract gconf menu items for i18n support
46d26319 315$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 316 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 317 $(obj)/gconf.glade
This page took 0.692984 seconds and 5 git commands to generate.